{
  wayland.windowManager.hyprland.settings = {
    workspace = [
      "special:youtube, on-created-empty:uwsm app -- firefox -P YouTube --name youtube"
      "special:music, on-created-empty:hakase-music-launch"
    ];

    windowrulev2 = [
      # --- POPUP RULES (Wifi, BT, Audio) ---
      "float, class:^(org\.hakase\.popup\..*)$"
      "animation slide right, class:^(org\.hakase\.popup\..*)$"
      "dimaround, class:^(org\.hakase\.popup\..*)$"
      # --- WALLPAPER PICKER ---
      "float, class:^(org\.hakase\.switch-wallpaper)$"
      "float, initialTitle:^(Wallpaper Selector)$"
      "center, class:^(org\.hakase\.switch-wallpaper)$"
      "center, initialTitle:^(Wallpaper Selector)$"
      "size 60% 60%, class:^(org\.hakase\.switch-wallpaper)$"
      "size 60% 60%, initialTitle:^(Wallpaper Selector)$"
      "dimaround, class:^(org\.hakase\.switch-wallpaper)$"
      "dimaround, initialTitle:^(Wallpaper Selector)$"

      # Prevent Firefox and Terminal from stealing focus on launch
      "suppressevent activate, workspace:special:preload"
      "noinitialfocus, workspace:special:preload"
      "suppressevent activate, class:^(firefox)$, workspace:special:preload"
      "noinitialfocus, class:^(firefox)$, workspace:special:preload"

      # --- STEAM RULES ---
      "workspace special:steam silent, class:^(steam)$"
      "noinitialfocus, class:^(steam)$"
      "suppressevent activate, class:^(steam)$"

      # --- MUSIC RULES (Jellyfin-TUI) ---
      "workspace special:music silent, title:^(jellyfin-tui)$"
      "workspace special:music silent, initialTitle:^(jellyfin-tui)$"

      # --- CAVA RULES ---
      "workspace special:music silent, title:^(cava)$"
      "workspace special:music silent, initialTitle:^(cava)$"

      # --- YOUTUBE RULES ---
      "workspace special:youtube, class:^(youtube)$"

      # --- GAMING RULES ---
      # Steam Apps, Gamescope, Lutris, Heroic, and Wine/Proton apps
      "fullscreen, class:^steam_app_\d+$"
      "monitor 0, class:^steam_app_\d+$"
      "workspace 1, class:^steam_app_\d+$"

      "fullscreen, class:^(gamescope)$"
      "fullscreen, class:^(lutris)$"
      "fullscreen, class:^(heroic)$"
      "fullscreen, class:^wine-.*$"
      "fullscreen, title:^Wine .*$"

      # --- IMAGE VIEWER (Loupe) ---
      "float, class:^(org\.gnome\.Loupe)$"
      "center, class:^(org\.gnome\.Loupe)$"
      "size 70% 70%, class:^(org\.gnome\.Loupe)$"

    ];
  };
}
